#include "hmg.ch"

#require "hbtip"
#require "hbssl"

REQUEST __HBEXTERN__HBSSL__

PROCEDURE Main()

   LOCAL cUrl := "https://google.com/"
   LOCAL oCon, oUrl, i

   oUrl := TUrl():New( cUrl )
   IF Empty( oUrl )
      ? "Invalid url " + cUrl
      ?
      INKEY( 0 )
      QUIT
   ENDIF

   IF oUrl:cProto != "https"
      ? "This is a header test for https."
      ? "Use an https address."
      ?
      INKEY( 0 )
      QUIT
   ENDIF

   oCon := TIPClientHTTP():New( oUrl )
   oCon:nConnTimeout := 20000
   ? "Connecting with", oUrl:cServer
   IF oCon:Open( cUrl )
      ? "Connection eshtablished"
      ? "Retreiving", oUrl:cPath, oUrl:cFile, oUrl:cQuery

      IF oCon:Get( oUrl:cPath )
         ? "Get Sucessful"
         FOR i := 1 TO Len( oCon:hHeaders )
            ? hb_HKeyAt( oCon:hHeaders, i ) + ":", hb_HValueAt( oCon:hHeaders, i )
         NEXT
      ELSE
         ? "Get failure (server reply:", oCon:cReply, ")"
      ENDIF

      oCon:Close()
   ELSE
      ? "Can't connect with", oUrl:cServer
      IF oCon:SocketCon == NIL
         ? "Connection not initiated"
      ELSEIF hb_inetErrorCode( oCon:SocketCon ) == 0
         ? "Server sayed:", oCon:cReply
      ELSE
         ? "Error in connection:", hb_inetErrorDesc( oCon:SocketCon )
      ENDIF
   ENDIF

   ? "Done"
   ?
   INKEY( 0 )
   RETURN
